"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var testing_1 = require("@angular/core/testing");
var platform_browser_1 = require("@angular/platform-browser");
var platform_browser_2 = require("@angular/platform-browser");
var testing_helpers_1 = require("./testing-helpers");
var expansion_panel_1 = require("../expansion-panel");
describe('TagInputComponent', function () {
    var fixture, panel, secondPanel;
    beforeEach(function () {
        testing_1.TestBed.configureTestingModule({
            declarations: [],
            imports: [platform_browser_2.BrowserModule, testing_helpers_1.TestModule]
        });
    });
    beforeEach(testing_1.async(function () {
        testing_1.TestBed.compileComponents();
    }));
    function getComponent(_fixture, nth) {
        _fixture.detectChanges();
        return _fixture.debugElement
            .queryAll(platform_browser_1.By.directive(expansion_panel_1.ExpansionPanelComponent))[nth].componentInstance;
    }
    describe('Basic behaviours', function () {
        beforeEach(function () {
            fixture = testing_1.TestBed.createComponent(testing_helpers_1.TestComponent);
            panel = getComponent(fixture, 0);
            secondPanel = getComponent(fixture, 1);
        });
        it('should always have a container', function () {
            expect(panel).toBeDefined();
            expect(panel.container).toBeDefined();
            expect(panel.isToggled).toBe(false);
        });
    });
    describe('Toggling', function () {
        beforeEach(function () {
            fixture = testing_1.TestBed.createComponent(testing_helpers_1.TestComponent);
            panel = getComponent(fixture, 0);
            secondPanel = getComponent(fixture, 1);
        });
        it('should toggle the first panel', function () {
            panel.toggle();
            expect(panel.isToggled).toBe(true);
        });
        it('should toggle the second panel after the first', function () {
            panel.toggle();
            expect(panel.isToggled).toBe(true);
            secondPanel.toggle();
            expect(panel.isToggled).not.toBe(true);
            expect(secondPanel.isToggled).toBe(true);
        });
        it('should emit events when a panel is toggled', function () {
            var onOpen = spyOn(fixture.componentInstance, 'onOpen');
            var onClose = spyOn(fixture.componentInstance, 'onClose');
            panel.toggle();
            expect(onOpen).toHaveBeenCalled();
            panel.toggle();
            expect(onClose).toHaveBeenCalled();
        });
    });
});
//# sourceMappingURL=expansion-panels.spec.js.map